<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function ArticlesPagesEdit
 * A function to edit article pages
 * @author Philipp Louis Esselbach
 */
function ArticlesPagesEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','articles_header','articles_pages_edit','articles_pages_edit_wysiwyg','articles_footer','articles_editreason','articles_error_na','articles_error_noadmin','articles_error_notauthor'", $preferences[ 'current_theme' ] );

	if( !$id )
	{
		$id = 1;
	}

	$insert = $system -> getinsert( $preferences, $main_templates );
	$query = $database -> dbquery( "SELECT a1.article_id, a1.article_author, a1.article_category, a1.article_title, a1.article_seo, a1.article_summary, a1.article_description, a1.article_keywords, a1.article_teaser, a1.article_comments, a1.article_allowcomments, a1.article_html, a1.article_smilies, a1.article_code, a1.article_status, a1.article_password, a1.article_date, a1.article_fields, a1.article_views, a1.article_rating, a1.article_votes, a2.articlepage_id, a2.articlepage_page, a2.articlepage_title, a2.articlepage_rawtext, a2.articlepage_editadmin FROM " . DB_PREFIX . "esselbach_ct_articles a1, " . DB_PREFIX . "esselbach_ct_articlespages a2 WHERE a2.articlepage_article = a1.article_id AND a2.articlepage_id = '" . $id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'article_id' ], $insert[ 'article_author' ], $insert[ 'article_category' ], $insert[ 'article_title' ], $insert[ 'article_seo' ], $insert[ 'article_summary' ], $insert[ 'article_description' ], $insert[ 'article_keywords' ], $insert[ 'article_teaser' ], $insert[ 'article_comments' ], $insert[ 'article_allowcomments' ], $insert[ 'article_html' ], $insert[ 'article_smilies' ], $insert[ 'article_code' ], $insert[ 'article_status' ], $insert[ 'article_password' ], $insert[ 'article_date' ], $insert[ 'article_fields' ], $insert[ 'article_views' ], $insert[ 'article_rating' ], $insert[ 'article_votes' ], $insert[ 'articlepage_id' ], $insert[ 'articlepage_page' ], $insert[ 'articlepage_title' ], $insert[ 'articlepage_text' ], $insert[ 'articlepage_editadmin' ] ) = $database -> dbrow( $query );
		$insert[ 'article_title' ] = htmlspecialchars( $insert[ 'article_title' ] );
		$insert[ 'articlepage_text' ] = htmlspecialchars( $insert[ 'articlepage_text' ] );
		$insert[ 'page_name' ] = $insert[ 'article_title' ];
		$insert[ 'page_description' ] = $insert[ 'article_description' ];
		$insert[ 'page_keywords' ] = $insert[ 'article_keywords' ];
	}
	else
	{
		$insert[ 'page_name' ] = $preferences[ 'website_name' ];
		$insert[ 'page_description' ] = $preferences[ 'website_description' ];
		$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	}

	if( $user[ 'user_status' ] != 2 )
	{
		$error = $templates -> exectemplate( $main_templates[ 'articles_error_noadmin_html' ], $main_templates[ 'articles_error_noadmin_php' ], $insert );
	}

	if( $user[ 'user_status' ] == 2 and $insert[ 'article_author' ] != $user[ 'user_name' ] )
	{
		$error = $templates -> exectemplate( $main_templates[ 'articles_error_notauthor_html' ], $main_templates[ 'articles_error_notauthor_php' ], $insert );
	}

	$input_articlepage_title = ( isset( $_POST[ 'input_articlepage_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_articlepage_title' ] ) : "" ;
	$input_articlepage_text = ( isset( $_POST[ 'input_articlepage_text' ] ) ) ? $security -> checkvar( $_POST[ 'input_articlepage_text' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_articlepage_title or $input_articlepage_text ) and( !isset( $error ) ) )
	{
		session_start();

		if( ( $_SESSION[ 'articles_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		if( $preferences[ 'articles_undo' ] )
		{
			$old_title = $database -> dbescape( $insert[ 'articlepage_title' ] );
			$old_text = $database -> dbescape( $insert[ 'articlepage_text' ] );
			$old_editadmin = $database -> dbescape( $insert[ 'articlepage_editadmin' ] );
			$edit_reason = $database -> dbescape( $templates -> exectemplate( $main_templates[ 'articles_editreason_html' ], $main_templates[ 'articles_editreason_php' ], $insert ) );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlespagesundo (articlepageundo_id, articlepageundo_pageid, articlepageundo_title, articlepageundo_text, articlepageundo_date, articlepageundo_editip, articlepageundo_editadmin, articlepageundo_editreason) VALUES (NULL, '" . $id . "', '" . $old_title . "', '" . $old_text . "', now(), '" . $ipaddr . "', '" . $old_editadmin . "', '" . $edit_reason . "')" );
		}

		$input_username = $database -> dbescape( $user[ 'user_name' ] );
		$input_articlepage_text_parsed = stripslashes( $input_articlepage_text );

		if( !$insert[ 'article_html' ] )
		{
			$input_articlepage_text_parsed = $system -> dechomp( $input_articlepage_text_parsed );
		}

		if( $insert[ 'article_smilies' ] )
		{
			$input_articlepage_text_parsed = $system -> smilies( $input_articlepage_text_parsed );
		}

		if( $insert[ 'article_code' ] )
		{
			$input_articlepage_text_parsed = $system -> code( $input_articlepage_text_parsed );
			$input_articlepage_text_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=articles&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_articlepage_text_parsed );
			$input_articlepage_text_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=articles&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_articlepage_text_parsed );
			$input_articlepage_text_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\"><img src=\"contentteller.php?ct=articles&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_articlepage_text_parsed );
		}

		$input_articlepage_text_parsed = $database -> dbescape( $input_articlepage_text_parsed );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlespages SET articlepage_title = '" . $input_articlepage_title . "', articlepage_rawtext = '" . $input_articlepage_text . "', articlepage_text = '" . $input_articlepage_text_parsed . "', articlepage_editip = '" . $ipaddr . "', articlepage_editadmin = '" . $input_username . "' WHERE articlepage_id = '" . $id . "'" );
		header( "Location: {$insert['site_url']}/contentteller.php?ct=articles&action=pages&page=" . $insert[ 'article_seo' ] . "," . $insert[ 'articlepage_page' ] . ".html" );
		exit;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'articles_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'articles_header_html' ], $main_templates[ 'articles_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'articles_security_hash' ] = $system -> dorand();
		$_SESSION[ 'articles_security_hash' ] = $insert[ 'articles_security_hash' ];

		if( $insert[ 'article_html' ] and $preferences[ 'articles_wysiwyg' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'articles_pages_edit_wysiwyg_html' ], $main_templates[ 'articles_pages_edit_wysiwyg_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'articles_pages_edit_html' ], $main_templates[ 'articles_pages_edit_php' ], $insert );
		}
	}

	if( $preferences[ 'articles_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'articles_footer_html' ], $main_templates[ 'articles_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>