<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function ArticlesSummaryEdit
 * A function to edit the article summary
 * @author Philipp Louis Esselbach
 */
function ArticlesSummaryEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','articles_header','articles_summary_edit','articles_rating_1star','articles_rating_2stars','articles_rating_3stars','articles_rating_4stars','articles_rating_5stars','articles_footer','articles_editreason','articles_error_na','articles_error_noadmin','articles_error_notauthor'", $preferences[ 'current_theme' ] );

	if( !$id )
	{
		$id = 1;
	}

	$insert = $system -> getinsert( $preferences, $main_templates );
	$query = $database -> dbquery( "SELECT article_id, article_author, article_title, article_description, article_keywords, article_seo, article_summary FROM " . DB_PREFIX . "esselbach_ct_articles WHERE article_id = '" . $id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'article_id' ], $insert[ 'article_author' ], $insert[ 'article_title' ], $insert[ 'article_description' ], $insert[ 'article_keywords' ], $insert[ 'article_seo' ], $insert[ 'article_summary' ] ) = $database -> dbrow( $query );
		$insert[ 'article_title' ] = htmlspecialchars( $insert[ 'article_title' ] );
		$insert[ 'article_summary' ] = htmlspecialchars( $insert[ 'article_summary' ] );
		$insert[ 'page_name' ] = $insert[ 'article_title' ];
		$insert[ 'page_description' ] = $insert[ 'article_description' ];
		$insert[ 'page_keywords' ] = $insert[ 'article_keywords' ];
	}
	else
	{
		$insert[ 'page_name' ] = $preferences[ 'website_name' ];
		$insert[ 'page_description' ] = $preferences[ 'website_description' ];
		$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	}

	if( $user[ 'user_status' ] != 2 )
	{
		$error = $templates -> exectemplate( $main_templates[ 'articles_error_noadmin_html' ], $main_templates[ 'articles_error_noadmin_php' ], $insert );
	}

	if( $user[ 'user_status' ] == 2 and $insert[ 'article_author' ] != $user[ 'user_name' ] )
	{
		$error = $templates -> exectemplate( $main_templates[ 'articles_error_notauthor_html' ], $main_templates[ 'articles_error_notauthor_php' ], $insert );
	}

	$input_article_title = ( isset( $_POST[ 'input_article_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_title' ] ) : "" ;
	$input_article_summary = ( isset( $_POST[ 'input_article_summary' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_summary' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_article_title or $input_article_summary ) and( !isset( $error ) ) )
	{
		session_start();

		if( $_SESSION[ 'articles_security_hash' ] != $input_security_hash )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articles SET article_title = '" . $input_article_title . "', article_summary = '" . $input_article_summary . "', article_editip = '" . $ipaddr . "', article_editadmin = '" . $database -> dbescape( $user[ 'user_name' ] ) . "' WHERE article_id = '" . $id . "'" );
		header( "Location: {$insert['site_url']}/contentteller.php?ct=articles&action=summary&page=" . $insert[ 'article_seo' ] . ".html" );
		exit;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'articles_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'articles_header_html' ], $main_templates[ 'articles_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'articles_security_hash' ] = $system -> dorand();
		$_SESSION[ 'articles_security_hash' ] = $insert[ 'articles_security_hash' ];
		echo $templates -> exectemplate( $main_templates[ 'articles_summary_edit_html' ], $main_templates[ 'articles_summary_edit_php' ], $insert );
	}

	if( $preferences[ 'news_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'articles_footer_html' ], $main_templates[ 'articles_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>