<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Content
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function ContentEdit
 * A function to edit content pages
 * @author Philipp Louis Esselbach
 */
function ContentEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','content_page_header','content_page_edit','content_page_edit_wysiwyg','content_page_footer','content_category_nav','content_page_editreason','content_page_error_na','content_page_error_noadmin','content_page_error_jradmin'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );

	if( $id )
	{
		$query = $database -> dbquery( "SELECT content_id, content_seo, content_title, content_rawtext, content_author, content_category, content_html, content_smilies, content_code, content_description, content_keywords, content_form, content_date FROM " . DB_PREFIX . "esselbach_ct_content WHERE content_id = '" . $id . "'" );
		list( $insert[ 'content_id' ], $insert[ 'content_seo' ], $insert[ 'content_title' ], $insert[ 'content_text' ], $insert[ 'content_author' ], $insert[ 'content_category' ], $insert[ 'content_html' ], $insert[ 'content_smilies' ], $insert[ 'content_code' ], $insert[ 'content_description' ], $insert[ 'content_keywords' ], $insert[ 'content_form' ], $insert[ 'content_date' ] ) = $database -> dbrow( $query );
		$insert[ 'contentcat_nav' ] = "";
		$insert[ 'contentcat_index' ] = 1;

		if( $insert[ 'content_category' ] )
		{
			$query = $database -> dbquery( "SELECT contentcat_parents FROM " . DB_PREFIX . "esselbach_ct_contentcats WHERE contentcat_id = '" . $insert[ 'content_category' ] . "'" );
			list( $insert[ 'contentcat_parents' ] ) = $database -> dbrow( $query );
			$query = $database -> dbquery( "SELECT contentcat_id, contentcat_name, contentcat_description FROM " . DB_PREFIX . "esselbach_ct_contentcats WHERE contentcat_id IN ($insert[contentcat_parents], $insert[content_category]) ORDER BY contentcat_id" );

			while( list( $insert[ 'contentcat_id' ], $insert[ 'contentcat_name' ], $insert[ 'contentcat_description' ] ) = $database -> dbrow( $query ) )
			{
				$insert[ 'contentcat_nav' ] .= $templates -> exectemplate( $main_templates[ 'content_category_nav_html' ], $main_templates[ 'content_category_nav_php' ], $insert );
			}
		}
	}
	else
	{
		$query = $database -> dbquery( "SELECT content_id, content_seo, content_title, content_rawtext, content_author, content_html, content_smilies, content_code, content_description, content_keywords, content_form, content_date FROM " . DB_PREFIX . "esselbach_ct_content WHERE content_frontpage = '1' ORDER BY content_date DESC LIMIT 1" );
		list( $insert[ 'content_id' ], $insert[ 'content_seo' ], $insert[ 'content_title' ], $insert[ 'content_text' ], $insert[ 'content_author' ], $insert[ 'content_html' ], $insert[ 'content_smilies' ], $insert[ 'content_code' ], $insert[ 'content_description' ], $insert[ 'content_keywords' ], $insert[ 'content_form' ], $insert[ 'content_date' ] ) = $database -> dbrow( $query );
		$insert[ 'content_title' ] = htmlspecialchars( $insert[ 'content_title' ] );
		$insert[ 'content_text' ] = htmlspecialchars( $insert[ 'content_text' ] );
	}

	if( $user[ 'user_status' ] == 1 or $user[ 'user_status' ] == 4 or $user[ 'user_status' ] == 5 or $user[ 'user_status' ] == 6 or !$user[ 'user_status' ] )
	{
		$error = $templates -> exectemplate( $main_templates[ 'content_page_error_noadmin_html' ], $main_templates[ 'content_page_error_noadmin_php' ], $insert );
	}

	if( $user[ 'user_status' ] == 3 )
	{
		if( $insert[ 'content_author' ] != $user[ 'user_name' ] )
		{
			$error = $templates -> exectemplate( $main_templates[ 'content_page_error_jradmin_html' ], $main_templates[ 'content_page_error_jradmin_php' ], $insert );
		}
	}

	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	$input_content_title = ( isset( $_POST[ 'input_content_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_content_title' ] ) : "" ;
	$input_content_text = ( isset( $_POST[ 'input_content_text' ] ) ) ? $security -> checkvar( $_POST[ 'input_content_text' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_content_title or $input_content_text ) and( !isset( $error ) ) )
	{
		session_start();

		if( ( $_SESSION[ 'content_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		if( $preferences[ 'content_undo' ] )
		{
			$old_author = $database -> dbescape( $insert[ 'content_author' ] );
			$old_title = $database -> dbescape( $insert[ 'content_title' ] );
			$old_text = $database -> dbescape( $insert[ 'content_text' ] );
			$old_description = $database -> dbescape( $insert[ 'content_description' ] );
			$old_keywords = $database -> dbescape( $insert[ 'content_keywords' ] );
			$old_form = $database -> dbescape( $insert[ 'content_form' ] );
			$old_date = $database -> dbescape( $insert[ 'content_date' ] );
			$edit_reason = $database -> dbescape( $templates -> exectemplate( $main_templates[ 'content_page_editreason_html' ], $main_templates[ 'content_page_editreason_php' ], $insert ) );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_contentundo (contentundo_id, contentundo_page, contentundo_author, contentundo_title, contentundo_text, contentundo_description, contentundo_keywords, contentundo_form, contentundo_date, contentundo_ip, contentundo_editreason) VALUES (NULL, '" . $id . "', '" . $old_author . "', '" . $old_title . "', '" . $old_text . "', '" . $old_description . "', '" . $old_keywords . "', '" . $old_form . "', '" . $old_date . "', '" . $ipaddr . "', '" . $edit_reason . "')" );
		}

		$input_username = $database -> dbescape( $user[ 'user_name' ] );
		$input_page_parsed = stripslashes( $input_content_text );

		if( !$insert[ 'content_html' ] )
		{
			$input_page_parsed = $system -> dechomp( $input_page_parsed );
		}

		if( $insert[ 'content_smilies' ] )
		{
			$input_page_parsed = $system -> smilies( $input_page_parsed );
		}

		if( $insert[ 'content_code' ] )
		{
			$input_page_parsed = $system -> code( $input_page_parsed );
			$input_page_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=content&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_page_parsed );
			$input_page_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=content&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_page_parsed );
			$input_page_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "content" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\"><img src=\"contentteller.php?ct=content&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_page_parsed );
		}

		$input_page_parsed = $database -> dbescape( $input_page_parsed );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_content SET content_author = '" . $input_username . "', content_title = '" . $input_content_title . "', content_rawtext = '" . $input_content_text . "', content_text = '" . $input_page_parsed . "', content_date = now(), content_editip = '" . $ipaddr . "' WHERE content_id = '" . $id . "'" );
		header( "Location: " . $insert[ 'site_url' ] . "/contentteller" . $insert[ 'param_ext' ] . $insert[ 'param_ct' ] . "content" . $insert[ 'param_action' ] . "page" . $insert[ 'param_page' ] . $insert[ 'content_seo' ] . ".html" );
		exit;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $insert[ 'contentcat_index' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'content_page_header_html' ], $main_templates[ 'content_page_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'content_security_hash' ] = $system -> dorand();
		$_SESSION[ 'content_security_hash' ] = $insert[ 'content_security_hash' ];

		if( $insert[ 'content_html' ] and $preferences[ 'content_wysiwyg' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'content_page_edit_wysiwyg_html' ], $main_templates[ 'content_page_edit_wysiwyg_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'content_page_edit_html' ], $main_templates[ 'content_page_edit_php' ], $insert );
		}
	}

	if( isset( $insert[ 'contentcat_index' ] ) )
	{
		echo $templates -> exectemplate( $main_templates[ 'content_page_footer_html' ], $main_templates[ 'content_page_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>