<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function FilesArchiveMonth
 * A function to show a files archive month
 * @author Philipp Louis Esselbach
 */
function FilesArchiveMonth( $page )
{
	global $database, $templates, $system, $user, $preferences;
	$templates -> initgzip();
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','files_header','files_archive_header','files_archive_file_header','files_archive_file','files_archive_file_day','files_archive_file_nav','files_archive_file_nav_previous','files_archive_file_nav_next','files_archive_error_month','files_rating_1star','files_rating_2stars','files_rating_3stars','files_rating_4stars','files_rating_5stars','files_archive_file_footer','files_archive_footer','files_footer','files_layout_archive_month'", $preferences[ 'current_theme' ] );
	$id = $system -> getpage( $page );
	$archive_year = substr( $id, 0, 4 );
	$archive_month = substr( $id, 4, 2 );
	$archive_files = "";
	$currentdate = date( "Y-m-d H:i:s", mktime() );
	$insert = $system -> getinsert( $preferences, $main_templates );

	if( $user[ 'user_status' ] == 1 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3')";
	}
	elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '2' OR file_status = '3' OR file_status = '4')";
	}
	elseif( $user[ 'user_status' ] == 6 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3' OR file_status = '4')";
	}
	else
	{
		$file_status = "(file_status = '0' OR file_status = '3')";
	}

	if( $preferences[ 'files_start_expire_date' ] )
	{
		$files_expire_sql = " AND file_startdate < '" . $currentdate . "' AND (file_expiredate > '" . $currentdate . "' OR file_neverexpire = '1')";
	}
	else
	{
		$files_expire_sql = "";
	}

	if( $preferences[ 'files_forum_comments' ] )
	{
		$file_threads = array();
		$query = $database -> dbquery( "SELECT file_thread FROM " . DB_PREFIX . "esselbach_ct_files WHERE (file_date LIKE '%" . $archive_year . "-" . $archive_month . "%') AND " . $file_status . " AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "')" . $files_expire_sql . " ORDER BY file_date" );

		if( $database -> dbrows( $query ) )
		{
			while( list( $file_thread ) = $database -> dbrow( $query ) )
			{
				if( $file_thread )
				{
					$file_threads[ ] = "'" . $file_thread . "'";
				}
			}

			$file_threads_comments = $uwrapper -> getcomments( $file_threads );
		}
	}

	$query = $database -> dbquery( "SELECT file_id, file_author, file_name, file_version, file_seo, file_description, file_status, file_teaser, file_date, file_rating, file_votes, file_comments, file_thread FROM " . DB_PREFIX . "esselbach_ct_files WHERE (file_date LIKE '%" . $archive_year . "-" . $archive_month . "%') AND " . $file_status . " AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "')" . $files_expire_sql . " ORDER BY file_date" );
	$archive_day = 0;

	if( $database -> dbrows( $query ) )
	{
		while( list( $insert[ 'file_id' ], $insert[ 'file_author' ], $insert[ 'file_name' ], $insert[ 'file_version' ], $insert[ 'file_seo' ], $insert[ 'file_description' ], $insert[ 'file_status' ], $insert[ 'file_teaser' ], $insert[ 'file_date' ], $insert[ 'file_rating' ], $insert[ 'file_votes' ], $insert[ 'file_comments' ], $insert[ 'file_thread' ] ) = $database -> dbrow( $query ) )
		{
			if( $preferences[ 'files_forum_comments' ] )
			{
				if( isset( $file_threads_comments[ $insert[ 'file_thread' ] ] ) )
				{
					$insert[ 'file_comments' ] = $file_threads_comments[ $insert[ 'file_thread' ] ];
				}
			}

			$insert[ 'file_name' ] = htmlspecialchars( $insert[ 'file_name' ] );
			$insert[ 'file_version' ] = htmlspecialchars( $insert[ 'file_version' ] );
			$insert[ 'file_author' ] = htmlspecialchars( $insert[ 'file_author' ] );
			$insert[ 'file_description' ] = htmlspecialchars( $insert[ 'file_description' ] );
			$current_archive_day = $system -> convertdate( $insert[ 'file_date' ], "%d", $preferences[ 'website_timezone' ] );

			if( $archive_day != $current_archive_day )
			{
				$insert[ 'archive_day' ] = $system -> convertdate( $insert[ 'file_date' ], $preferences[ 'files_day_dateformat' ], $preferences[ 'website_timezone' ] );
				$archive_files .= $templates -> exectemplate( $main_templates[ 'files_archive_file_day_html' ], $main_templates[ 'files_archive_file_day_php' ], $insert );
				$archive_day = $current_archive_day;
				$file_date = $insert[ 'file_date' ];
				$file_search_date = $archive_year . "-" . $archive_month;
			}

			if( $preferences[ 'files_allow_rating' ] and $insert[ 'file_votes' ] )
			{
				if( $insert[ 'file_rating' ] == 5 )
				{
					$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_5stars_html' ], $main_templates[ 'files_rating_5stars_php' ], $insert );
				}
				elseif( $insert[ 'file_rating' ] == 4 )
				{
					$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_4stars_html' ], $main_templates[ 'files_rating_4stars_php' ], $insert );
				}
				elseif( $insert[ 'file_rating' ] == 3 )
				{
					$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_3stars_html' ], $main_templates[ 'files_rating_3stars_php' ], $insert );
				}
				elseif( $insert[ 'file_rating' ] == 2 )
				{
					$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_2stars_html' ], $main_templates[ 'files_rating_2stars_php' ], $insert );
				}
				elseif( $insert[ 'file_rating' ] < 2 )
				{
					$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_1star_html' ], $main_templates[ 'files_rating_1star_php' ], $insert );
				}
			}
			else
			{
				$insert[ 'file_rating_line' ] = "";
			}

			$archive_files .= $templates -> exectemplate( $main_templates[ 'files_archive_file_html' ], $main_templates[ 'files_archive_file_php' ], $insert );
		}
	}

	$insert[ 'file_month' ] = strftime( "%B %Y", mktime( 0, 0, 0, $archive_month, 1, $archive_year ) );
	$insert[ 'file_month_id' ] = $archive_year . $archive_month;
	$insert[ 'page_name' ] = htmlspecialchars( $preferences[ 'website_name' ] );
	$insert[ 'page_description' ] = htmlspecialchars( $preferences[ 'website_description' ] );
	$insert[ 'page_keywords' ] = htmlspecialchars( $preferences[ 'website_keywords' ] );
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'files_navigation' ] )
	{
		if( $archive_files )
		{
			$insert[ 'files_header' ] = $templates -> exectemplate( $main_templates[ 'files_archive_header_html' ], $main_templates[ 'files_archive_header_php' ], $insert );
		}
		else
		{
			$insert[ 'files_header' ] = $templates -> exectemplate( $main_templates[ 'files_header_html' ], $main_templates[ 'files_header_php' ], $insert );
		}
	}

	if( $archive_files )
	{
		$insert[ 'files_archive_file_header' ] = $templates -> exectemplate( $main_templates[ 'files_archive_file_header_html' ], $main_templates[ 'files_archive_file_header_php' ], $insert );
		$insert[ 'files_archive_file' ] = $archive_files;
		$insert[ 'files_archive_file_footer' ] = $templates -> exectemplate( $main_templates[ 'files_archive_file_footer_html' ], $main_templates[ 'files_archive_file_footer_php' ], $insert );

		if( $preferences[ 'files_archive_navigation' ] )
		{

			if( $user[ 'user_status' ] == 1 )
			{
				$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3')";
			}
			elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
			{
				$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '2' OR file_status = '3' OR file_status = '4')";
			}
			elseif( $user[ 'user_status' ] == 4 )
			{
				$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3' OR file_status = '4')";
			}
			else
			{
				$file_status = "(file_status = '0' OR file_status = '3')";
			}

			$query = $database -> dbquery( "SELECT file_date FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_date < '" . $file_search_date . "-01 00:00:00' AND " . $file_status . " AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "')" . $files_expire_sql . " ORDER BY file_date DESC LIMIT 1" );
			list( $previous_date ) = $database -> dbrow( $query );

			if( $previous_date )
			{
				$insert[ 'file_month' ] = strftime( "%B %Y", strtotime( $previous_date ) );
				$insert[ 'file_month_id' ] = $system -> getmonth( $previous_date );
				$insert[ 'archive_previous_month' ] = $templates -> exectemplate( $main_templates[ 'files_archive_file_nav_previous_html' ], $main_templates[ 'files_archive_file_nav_previous_php' ], $insert );
			}
			else
			{
				$insert[ 'archive_previous_month' ] = "";
			}

			$query = $database -> dbquery( "SELECT file_date FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_date > '" . $file_search_date . "-31 23:59:59' AND " . $file_status . " AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "') ORDER BY file_date LIMIT 1" );
			list( $next_date ) = $database -> dbrow( $query );

			if( $next_date )
			{
				$insert[ 'file_month' ] = strftime( "%B %Y", strtotime( $next_date ) );
				$insert[ 'file_month_id' ] = $system -> getmonth( $next_date );
				$insert[ 'archive_next_month' ] = $templates -> exectemplate( $main_templates[ 'files_archive_file_nav_next_html' ], $main_templates[ 'files_archive_file_nav_next_php' ], $insert );
			}
			else
			{
				$insert[ 'archive_next_month' ] = "";
			}

			$insert[ 'archive_current_month' ] = strftime( "%B %Y", strtotime( $file_date ) );
			$insert[ 'files_archive_file_nav' ] = $templates -> exectemplate( $main_templates[ 'files_archive_file_nav_html' ], $main_templates[ 'files_archive_file_nav_php' ], $insert );
		}
		else
		{
			$insert[ 'files_archive_file_nav' ] = "";
		}
	}
	else
	{
		$insert[ 'files_archive_file_header' ] = "";
		$insert[ 'files_archive_file' ] = $templates -> exectemplate( $main_templates[ 'files_archive_error_month_html' ], $main_templates[ 'files_archive_error_month_php' ], $insert );
		$insert[ 'files_archive_file_footer' ] = "";
		$insert[ 'files_archive_file_nav' ] = "";
	}

	if( $preferences[ 'files_navigation' ] )
	{
		if( $archive_files )
		{
			$insert[ 'files_footer' ] = $templates -> exectemplate( $main_templates[ 'files_archive_footer_html' ], $main_templates[ 'files_archive_footer_php' ], $insert );
		}
		else
		{
			$insert[ 'files_footer' ] = $templates -> exectemplate( $main_templates[ 'files_footer_html' ], $main_templates[ 'files_footer_php' ], $insert );
		}
	}

	echo $templates -> exectemplate( $main_templates[ 'files_layout_archive_month_html' ], $main_templates[ 'files_layout_archive_month_php' ], $insert );
	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>