<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function FilesEdit
 * A function to edit a file
 * @author Philipp Louis Esselbach
 */
function FilesEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','files_details_header','files_edit','files_edit_wysiwyg','files_rating_1star','files_rating_2stars','files_rating_3stars','files_rating_4stars','files_rating_5stars','files_details_footer','files_editreason','files_error_na','files_error_noadmin','files_error_notauthor'", $preferences[ 'current_theme' ] );

	if( !$id )
	{
		$id = 1;
	}

	$insert = $system -> getinsert( $preferences, $main_templates );
	$query = $database -> dbquery( "SELECT file_id, file_author, file_category, file_name, file_version, file_seo, file_rawsmalldescription, file_rawlongdescription, file_description, file_keywords, file_size, file_cost, file_company, file_homepage, file_email, file_pad, file_language, file_os, file_agreement, file_teaser, file_comments, file_allowcomments, file_html, file_smilies, file_code, file_status, file_password, file_date, file_startdate, file_expiredate, file_neverexpire, file_fields, file_views, file_rating, file_votes, file_editadmin FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_id = '" . $id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'file_id' ], $insert[ 'file_author' ], $insert[ 'file_category' ], $insert[ 'file_name' ], $insert[ 'file_version' ], $insert[ 'file_seo' ], $insert[ 'file_smalldescription' ], $insert[ 'file_longdescription' ], $insert[ 'file_description' ], $insert[ 'file_keywords' ], $insert[ 'file_size' ], $insert[ 'file_cost' ], $insert[ 'file_company' ], $insert[ 'file_homepage' ], $insert[ 'file_email' ], $insert[ 'file_pad' ], $insert[ 'file_language' ], $insert[ 'file_os' ], $insert[ 'file_agreement' ], $insert[ 'file_teaser' ], $insert[ 'file_comments' ], $insert[ 'file_allowcomments' ], $insert[ 'file_html' ], $insert[ 'file_smilies' ], $insert[ 'file_code' ], $insert[ 'file_status' ], $insert[ 'file_password' ], $insert[ 'file_date' ], $insert[ 'file_startdate' ], $insert[ 'file_expiredate' ], $insert[ 'file_neverexpire' ], $insert[ 'file_fields' ], $insert[ 'file_views' ], $insert[ 'file_rating' ], $insert[ 'file_votes' ], $insert[ 'file_editadmin' ] ) = $database -> dbrow( $query );
		$insert[ 'file_name' ] = htmlspecialchars( $insert[ 'file_name' ] );
		$insert[ 'file_version' ] = htmlspecialchars( $insert[ 'file_version' ] );
		$insert[ 'file_smalldescription' ] = htmlspecialchars( $insert[ 'file_smalldescription' ] );
		$insert[ 'file_longdescription' ] = htmlspecialchars( $insert[ 'file_longdescription' ] );
		$insert[ 'file_month' ] = $system -> convertdate( $insert[ 'file_date' ], "%B %Y", $preferences[ 'website_timezone' ] );
		$insert[ 'file_month_id' ] = $system -> getmonth( $insert[ 'file_date' ] );
		$insert[ 'page_name' ] = $insert[ 'file_name' ] . " " . $insert[ 'file_version' ];
		$insert[ 'page_description' ] = $insert[ 'file_description' ];
		$insert[ 'page_keywords' ] = $insert[ 'file_keywords' ];
	}
	else
	{
		$insert[ 'page_name' ] = $preferences[ 'website_name' ];
		$insert[ 'page_description' ] = $preferences[ 'website_description' ];
		$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	}

	if( $user[ 'user_status' ] != 2 )
	{
		$error = $templates -> exectemplate( $main_templates[ 'files_error_noadmin_html' ], $main_templates[ 'files_error_noadmin_php' ], $insert );
	}

	if( $user[ 'user_status' ] == 2 and $insert[ 'file_author' ] != $user[ 'user_name' ] )
	{
		$error = $templates -> exectemplate( $main_templates[ 'files_error_notauthor_html' ], $main_templates[ 'files_error_notauthor_php' ], $insert );
	}

	if( $preferences[ 'files_allow_rating' ] and $insert[ 'file_votes' ] )
	{
		if( $insert[ 'file_rating' ] == 5 )
		{
			$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_5stars_html' ], $main_templates[ 'files_rating_5stars_php' ], $insert );
		}
		elseif( $insert[ 'file_rating' ] == 4 )
		{
			$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_4stars_html' ], $main_templates[ 'files_rating_4stars_php' ], $insert );
		}
		elseif( $insert[ 'file_rating' ] == 3 )
		{
			$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_3stars_html' ], $main_templates[ 'files_rating_3stars_php' ], $insert );
		}
		elseif( $insert[ 'file_rating' ] == 2 )
		{
			$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_2stars_html' ], $main_templates[ 'files_rating_2stars_php' ], $insert );
		}
		elseif( $insert[ 'file_rating' ] < 2 )
		{
			$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_1star_html' ], $main_templates[ 'files_rating_1star_php' ], $insert );
		}
	}
	else
	{
		$insert[ 'file_rating_line' ] = "";
	}

	$input_file_name = ( isset( $_POST[ 'input_file_name' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_name' ] ) : "" ;
	$input_file_version = ( isset( $_POST[ 'input_file_version' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_version' ] ) : "" ;
	$input_file_smalldescription = ( isset( $_POST[ 'input_file_smalldescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_smalldescription' ] ) : "" ;
	$input_file_longdescription = ( isset( $_POST[ 'input_file_longdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_longdescription' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_file_name or $input_file_version or $input_file_smalldescription or $input_file_longdescription ) and( !isset( $error ) ) )
	{
		session_start();

		if( ( $_SESSION[ 'files_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		if( $preferences[ 'files_undo' ] )
		{
			$old_author = $database -> dbescape( $insert[ 'file_author' ] );
			$old_name = $database -> dbescape( $insert[ 'file_name' ] );
			$old_version = $database -> dbescape( $insert[ 'file_version' ] );
			$old_seo = $database -> dbescape( $insert[ 'file_seo' ] );
			$old_smalldescription = $database -> dbescape( $insert[ 'file_smalldescription' ] );
			$old_longdescription = $database -> dbescape( $insert[ 'file_longdescription' ] );
			$old_description = $database -> dbescape( $insert[ 'file_description' ] );
			$old_keywords = $database -> dbescape( $insert[ 'file_keywords' ] );
			$old_size = $database -> dbescape( $insert[ 'file_size' ] );
			$old_cost = $database -> dbescape( $insert[ 'file_cost' ] );
			$old_company = $database -> dbescape( $insert[ 'file_company' ] );
			$old_homepage = $database -> dbescape( $insert[ 'file_homepage' ] );
			$old_email = $database -> dbescape( $insert[ 'file_email' ] );
			$old_language = $database -> dbescape( $insert[ 'file_language' ] );
			$old_os = $database -> dbescape( $insert[ 'file_os' ] );
			$old_agreement = $database -> dbescape( $insert[ 'file_agreement' ] );
			$old_startdate = $database -> dbescape( $insert[ 'file_startdate' ] );
			$old_expiredate = $database -> dbescape( $insert[ 'file_expiredate' ] );
			$old_neverexpire = $database -> dbescape( $insert[ 'file_neverexpire' ] );
			$old_fields = $database -> dbescape( $insert[ 'file_fields' ] );
			$old_editadmin = $database -> dbescape( $insert[ 'file_editadmin' ] );
			$edit_reason = $database -> dbescape( $templates -> exectemplate( $main_templates[ 'files_editreason_html' ], $main_templates[ 'files_editreason_php' ], $insert ) );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesundo (fileundo_id, fileundo_file, fileundo_author, fileundo_name, fileundo_version, fileundo_seo, fileundo_smalldescription, fileundo_longdescription, fileundo_description, fileundo_keywords, fileundo_size, fileundo_cost, fileundo_company, fileundo_homepage, fileundo_email, fileundo_language, fileundo_os, fileundo_agreement, fileundo_fields, fileundo_date, fileundo_startdate, fileundo_expiredate, fileundo_neverexpire, fileundo_editip, fileundo_editadmin, fileundo_editreason) VALUES (NULL, '" . $id . "', '" . $old_author . "', '" . $old_name . "', '" . $old_version . "', '" . $old_seo . "', '" . $old_smalldescription . "', '" . $old_longdescription . "', '" . $old_description . "', '" . $old_keywords . "', '" . $old_size . "', '" . $old_cost . "', '" . $old_company . "', '" . $old_homepage . "', '" . $old_email . "', '" . $old_language . "', '" . $old_os . "', '" . $old_agreement . "', '" . $old_fields . "', now(), '" . $old_startdate . "', '" . $old_expiredate . "', '" . $old_neverexpire . "', '" . $ipaddr . "', '" . $old_editadmin . "', '" . $edit_reason . "')" );
		}

		$input_username = $database -> dbescape( $user[ 'user_name' ] );
		$input_file_smalldescription_parsed = stripslashes( $input_file_smalldescription );
		$input_file_longdescription_parsed = stripslashes( $input_file_longdescription );

		if( !$insert[ 'file_html' ] )
		{
			$input_file_smalldescription_parsed = $system -> dechomp( $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = $system -> dechomp( $input_file_longdescription_parsed );
		}

		if( $insert[ 'file_smilies' ] )
		{
			$input_file_smalldescription_parsed = $system -> smilies( $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = $system -> smilies( $input_file_longdescription_parsed );
		}

		if( $insert[ 'file_code' ] )
		{
			$input_file_smalldescription_parsed = $system -> code( $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = $system -> code( $input_file_longdescription_parsed );
			$input_file_smalldescription_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=files&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_file_smalldescription_parsed );
			$input_file_smalldescription_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=files&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_file_smalldescription_parsed );
			$input_file_smalldescription_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "files" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\"><img src=\"contentteller.php?ct=files&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=files&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_file_longdescription_parsed );
			$input_file_longdescription_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=files&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_file_longdescription_parsed );
			$input_file_longdescription_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "files" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\"><img src=\"contentteller.php?ct=files&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_file_longdescription_parsed );
		}

		$input_file_smalldescription_parsed = $database -> dbescape( $input_file_smalldescription_parsed );
		$input_file_longdescription_parsed = $database -> dbescape( $input_file_longdescription_parsed );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_files SET file_name = '" . $input_file_name . "', file_version = '" . $input_file_version . "', file_rawsmalldescription = '" . $input_file_smalldescription . "', file_smalldescription = '" . $input_file_smalldescription_parsed . "', file_rawlongdescription = '" . $input_file_longdescription . "', file_longdescription = '" . $input_file_longdescription_parsed . "', file_editip = '" . $ipaddr . "', file_editadmin = '" . $input_username . "' WHERE file_id = '" . $id . "'" );
		header( "Location: {$insert['site_url']}/contentteller.php?ct=files&action=details&page=" . $insert[ 'file_seo' ] . ".html" );
		exit;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'files_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'files_details_header_html' ], $main_templates[ 'files_details_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'files_security_hash' ] = $system -> dorand();
		$_SESSION[ 'files_security_hash' ] = $insert[ 'files_security_hash' ];

		if( $insert[ 'file_html' ] and $preferences[ 'files_wysiwyg' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'files_edit_wysiwyg_html' ], $main_templates[ 'files_edit_wysiwyg_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'files_edit_html' ], $main_templates[ 'files_edit_php' ], $insert );
		}
	}

	if( $preferences[ 'files_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'files_details_footer_html' ], $main_templates[ 'files_details_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>