<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Glossary
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function GlossaryEdit
 * A function to edit the glossary
 * @author Philipp Louis Esselbach
 */
function GlossaryEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','glossary_header','glossary_footer','glossary_list_edit','glossary_list_edit_wysiwyg','glossary_error_na','glossary_error_noadmin','glossary_error_notauthor'", $preferences[ 'current_theme' ] );

	if( !$id )
	{
		$id = 1;
	}

	$insert = $system -> getinsert( $preferences, $main_templates );
	$query = $database -> dbquery( "SELECT glossary_id, glossary_author, glossary_title, glossary_rawtext, glossary_html, glossary_smilies, glossary_code FROM " . DB_PREFIX . "esselbach_ct_glossary WHERE glossary_id = '" . $id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'glossary_id' ], $insert[ 'glossary_author' ], $insert[ 'glossary_title' ], $insert[ 'glossary_text' ], $insert[ 'glossary_html' ], $insert[ 'glossary_smilies' ], $insert[ 'glossary_code' ] ) = $database -> dbrow( $query );
		$insert[ 'glossary_title' ] = htmlspecialchars( $insert[ 'glossary_title' ] );
		$insert[ 'glossary_text' ] = htmlspecialchars( $insert[ 'glossary_text' ] );
		$insert[ 'glossary_name' ] = strtoupper( substr( $insert[ 'glossary_title' ], 0, 1 ) );
		$insert[ 'glossary_seo' ] = strtolower( substr( $insert[ 'glossary_title' ], 0, 1 ) );
		$insert[ 'page_name' ] = $insert[ 'glossary_title' ];

		if( $user[ 'user_status' ] != 2 )
		{
			$error = $templates -> exectemplate( $main_templates[ 'glossary_error_noadmin_html' ], $main_templates[ 'glossary_error_noadmin_php' ], $insert );
		}

		if( $user[ 'user_status' ] == 2 and $insert[ 'glossary_author' ] != $user[ 'user_name' ] )
		{
			$error = $templates -> exectemplate( $main_templates[ 'glossary_error_notauthor_html' ], $main_templates[ 'glossary_error_notauthor_php' ], $insert );
		}
	}
	else
	{
		$insert[ 'glossary_name' ] = "A";
		$insert[ 'glossary_seo' ] = "a";
		$insert[ 'page_name' ] = $preferences[ 'website_name' ];
		$error = $templates -> exectemplate( $main_templates[ 'glossary_error_na_html' ], $main_templates[ 'glossary_error_na_php' ], $insert );
	}

	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	$input_glossary_title = ( isset( $_POST[ 'input_glossary_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_glossary_title' ] ) : "" ;
	$input_glossary_text = ( isset( $_POST[ 'input_glossary_text' ] ) ) ? $security -> checkvar( $_POST[ 'input_glossary_text' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_glossary_title or $input_glossary_text ) and( !isset( $error ) ) )
	{
		session_start();

		if( ( $_SESSION[ 'glossary_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		$input_username = $database -> dbescape( $user[ 'user_name' ] );
		$input_glossary_text_parsed = stripslashes( $input_glossary_text );

		if( !$insert[ 'glossary_html' ] )
		{
			$input_glossary_text_parsed = $system -> dechomp( $input_glossary_text_parsed );
		}

		if( $insert[ 'glossary_smilies' ] )
		{
			$input_glossary_text_parsed = $system -> smilies( $input_glossary_text_parsed );
		}

		if( $insert[ 'glossary_code' ] )
		{
			$input_glossary_text_parsed = $system -> code( $input_glossary_text_parsed );
		}

		$input_glossary_text_parsed = $database -> dbescape( $input_glossary_text_parsed );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_glossary SET glossary_title = '" . $input_glossary_title . "', glossary_rawtext = '" . $input_glossary_text . "', glossary_text = '" . $input_glossary_text_parsed . "', glossary_editip = '" . $ipaddr . "', glossary_editadmin = '" . $input_username . "' WHERE glossary_id = '" . $id . "'" );
		header( "Location: {$insert['site_url']}/contentteller.php?ct=glossary&action=index&page=" . $insert[ 'glossary_seo' ] . ".html" );
		exit;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'glossary_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'glossary_header_html' ], $main_templates[ 'glossary_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'glossary_security_hash' ] = $system -> dorand();
		$_SESSION[ 'glossary_security_hash' ] = $insert[ 'glossary_security_hash' ];

		if( $insert[ 'glossary_html' ] and $preferences[ 'glossary_wysiwyg' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'glosssary_list_edit_wysiwyg_html' ], $main_templates[ 'glossary_list_edit_wysiwyg_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'glossary_list_edit_html' ], $main_templates[ 'glossary_list_edit_php' ], $insert );
		}
	}

	if( $preferences[ 'glossary_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'glossary_footer_html' ], $main_templates[ 'glossary_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>