<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Knowledgebase
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function KnowledgebaseEdit
 * A function to edit a knowledgebase entry
 * @author Philipp Louis Esselbach
 */
function KnowledgebaseEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','knowledgebase_header','knowledgebase_footer','knowledgebase_editreason','knowledgebase_entry_edit','knowledgebase_entry_edit_wysiwyg','knowledgebase_error_na','knowledgebase_error_noadmin','knowledgebase_error_notauthor'", $preferences[ 'current_theme' ] );

	if( !$id )
	{
		$id = 1;
	}

	$insert = $system -> getinsert( $preferences, $main_templates );
	$query = $database -> dbquery( "SELECT knowledgebase_id, knowledgebase_seo, knowledgebase_question, knowledgebase_rawanswer, knowledgebase_author, knowledgebase_category, knowledgebase_html, knowledgebase_smilies, knowledgebase_code, knowledgebase_description, knowledgebase_keywords, knowledgebase_date, knowledgebase_editip, knowledgebase_editadmin FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE knowledgebase_id = '" . $id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'knowledgebase_id' ], $insert[ 'knowledgebase_seo' ], $insert[ 'knowledgebase_question' ], $insert[ 'knowledgebase_answer' ], $insert[ 'knowledgebase_author' ], $insert[ 'knowledgebase_category' ], $insert[ 'knowledgebase_html' ], $insert[ 'knowledgebase_smilies' ], $insert[ 'knowledgebase_code' ], $insert[ 'knowledgebase_description' ], $insert[ 'knowledgebase_keywords' ], $insert[ 'knowledgebase_date' ], $insert[ 'knowledgebase_editip' ], $insert[ 'knowledgebase_editadmin' ] ) = $database -> dbrow( $query );

		$insert[ 'knowledgebase_question' ] = htmlspecialchars( $insert[ 'knowledgebase_question' ] );
		$insert[ 'knowledgebase_answer' ] = htmlspecialchars( $insert[ 'knowledgebase_answer' ] );

		if( $user[ 'user_status' ] != 2 )
		{
			$error = $templates -> exectemplate( $main_templates[ 'knowledgebase_error_noadmin_html' ], $main_templates[ 'knowledgebase_error_noadmin_php' ], $insert );
		}

		if( $user[ 'user_status' ] == 2 and $insert[ 'knowledgebase_author' ] != $user[ 'user_name' ] )
		{
			$error = $templates -> exectemplate( $main_templates[ 'knowledgebase_error_notauthor_html' ], $main_templates[ 'knowledgebase_error_notauthor_php' ], $insert );
		}
	}
	else
	{
		$error = $templates -> exectemplate( $main_templates[ 'knowledgebase_error_na_html' ], $main_templates[ 'knowledgebase_error_na_php' ], $insert );
	}

	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	$insert[ 'knowledgebasecat_nav' ] = "";
	$input_knowledgebase_question = ( isset( $_POST[ 'input_knowledgebase_question' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_question' ] ) : "" ;
	$input_knowledgebase_answer = ( isset( $_POST[ 'input_knowledgebase_answer' ] ) ) ? $security -> checkvar( $_POST[ 'input_knowledgebase_answer' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_knowledgebase_question or $input_knowledgebase_answer ) and( !isset( $error ) ) )
	{
		session_start();

		if( ( $_SESSION[ 'knowledgebase_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		$input_username = $database -> dbescape( $user[ 'user_name' ] );

		if( $preferences[ 'knowledgebase_undo' ] )
		{
			$old_author = $database -> dbescape( $insert[ 'knowledgebase_author' ] );
			$old_seo = $database -> dbescape( $insert[ 'knowledgebase_seo' ] );
			$old_question = $database -> dbescape( $insert[ 'knowledgebase_question' ] );
			$old_answer = $database -> dbescape( $insert[ 'knowledgebase_answer' ] );
			$old_description = $database -> dbescape( $insert[ 'knowledgebase_description' ] );
			$old_keywords = $database -> dbescape( $insert[ 'knowledgebase_keywords' ] );
			$old_editadmin = $database -> dbescape( $insert[ 'knowledgebase_editadmin' ] );
			$edit_reason = $database -> dbescape( $templates -> exectemplate( $main_templates[ 'knowledgebase_editreason_html' ], $main_templates[ 'knowledgebase_editreason_php' ], $insert ) );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_knowledgebaseundo (knowledgebaseundo_id, knowledgebaseundo_entry, knowledgebaseundo_author, knowledgebaseundo_question, knowledgebaseundo_seo, knowledgebaseundo_answer, knowledgebaseundo_description, knowledgebaseundo_keywords, knowledgebaseundo_date, knowledgebaseundo_editip, knowledgebaseundo_editadmin, knowledgebaseundo_editreason) VALUES (NULL, '" . $id . "', '" . $old_author . "', '" . $old_question . "', '" . $old_seo . "', '" . $old_answer . "', '" . $old_description . "', '" . $old_keywords . "', now(), '" . $ipaddr . "', '" . $old_editadmin . "', '" . $edit_reason . "')" );
		}

		$input_knowledgebase_answer_parsed = stripslashes( $input_knowledgebase_answer );

		if( !$insert[ 'knowledgebase_html' ] )
		{
			$input_knowledgebase_answer_parsed = $system -> dechomp( $input_knowledgebase_answer_parsed );
		}

		if( $insert[ 'knowledgebase_smilies' ] )
		{
			$input_knowledgebase_answer_parsed = $system -> smilies( $input_knowledgebase_answer_parsed );
		}

		if( $insert[ 'knowledgebase_code' ] )
		{
			$input_knowledgebase_answer_parsed = $system -> code( $input_knowledgebase_answer );
			$input_knowledgebase_answer_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=knowledgebase&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_knowledgebase_answer_parsed );
			$input_knowledgebase_answer_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=articles&amp;action=knowledgebase&amp;id=\\1\" alt=\"\" />", $input_knowledgebase_answer_parsed );
			$input_knowledgebase_answer_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "knowledgebase" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\"><img src=\"contentteller.php?ct=knowledgebase&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_knowledgebase_answer_parsed );
		}

		$input_knowledgebase_answer_parsed = $database -> dbescape( $input_knowledgebase_answer_parsed );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_knowledgebase SET knowledgebase_question = '" . $input_knowledgebase_question . "', knowledgebase_rawanswer = '" . $input_knowledgebase_answer . "', knowledgebase_answer = '" . $input_knowledgebase_answer_parsed . "', knowledgebase_editip = '" . $ipaddr . "', knowledgebase_editadmin = '" . $input_username . "' WHERE knowledgebase_id = '" . $id . "'" );
		$query = $database -> dbquery( "SELECT knowledgebase_seo FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE knowledgebase_id = '" . $id . "'" );
		list( $knowledgebase_seo ) = $database -> dbrow( $query );
		header( "Location: {$insert['site_url']}/contentteller.php?ct=knowledgebase&entry=" . $knowledgebase_seo . ".html" );
		exit;
	}

	$blocks = $templates -> prepareblocks( $main_templates[ 'site_block_html' ], $main_templates[ 'site_block_php' ], $insert );

	foreach( $blocks as $block_id => $block_knowledgebase )
	{
		$insert[ 'site_block_' . $block_id ] = $block_knowledgebase;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'knowledgebase_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'knowledgebase_header_html' ], $main_templates[ 'knowledgebase_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'knowledgebase_security_hash' ] = $system -> dorand();
		$_SESSION[ 'knowledgebase_security_hash' ] = $insert[ 'knowledgebase_security_hash' ];

		if( $insert[ 'knowledgebase_html' ] and $preferences[ 'knowledgebase_wysiwyg' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_edit_wysiwyg_html' ], $main_templates[ 'knowledgebase_entry_edit_wysiwyg_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'knowledgebase_entry_edit_html' ], $main_templates[ 'knowledgebase_entry_edit_php' ], $insert );
		}
	}

	if( $preferences[ 'knowledgebase_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'knowledgebase_footer_html' ], $main_templates[ 'knowledgebase_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>