<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Links
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function LinksEdit
 * A function to edit web links
 * @author Philipp Louis Esselbach
 */
function LinksEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','links_header','links_footer','links_list_edit','links_error_na','links_error_noadmin','links_error_notauthor'", $preferences[ 'current_theme' ] );

	if( !$id )
	{
		$id = 1;
	}

	$insert = $system -> getinsert( $preferences, $main_templates );
	$query = $database -> dbquery( "SELECT link_id, link_category, link_author, link_name, link_url, link_description FROM " . DB_PREFIX . "esselbach_ct_links WHERE link_id = '" . $id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'link_id' ], $insert[ 'link_category' ], $insert[ 'link_author' ], $insert[ 'link_name' ], $insert[ 'link_url' ], $insert[ 'link_description' ] ) = $database -> dbrow( $query );

		$insert[ 'link_name' ] = htmlspecialchars( $insert[ 'link_name' ] );
		$insert[ 'link_url' ] = htmlspecialchars( $insert[ 'link_url' ] );

		if( $user[ 'user_status' ] != 2 )
		{
			$error = $templates -> exectemplate( $main_templates[ 'links_error_noadmin_html' ], $main_templates[ 'links_error_noadmin_php' ], $insert );
		}

		if( $user[ 'user_status' ] == 2 and $insert[ 'link_author' ] != $user[ 'user_name' ] )
		{
			$error = $templates -> exectemplate( $main_templates[ 'links_error_notauthor_html' ], $main_templates[ 'links_error_notauthor_php' ], $insert );
		}
	}
	else
	{
		$error = $templates -> exectemplate( $main_templates[ 'links_error_na_html' ], $main_templates[ 'links_error_na_php' ], $insert );
	}

	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	$insert[ 'linkcat_nav' ] = "";
	$input_link_name = ( isset( $_POST[ 'input_link_name' ] ) ) ? $security -> checkvar( $_POST[ 'input_link_name' ] ) : "" ;
	$input_link_url = ( isset( $_POST[ 'input_link_url' ] ) ) ? $security -> checkvar( $_POST[ 'input_link_url' ] ) : "" ;
	$input_link_description = ( isset( $_POST[ 'input_link_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_link_description' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_link_name or $input_link_url or $input_link_description ) and( !isset( $error ) ) )
	{
		session_start();

		if( ( $_SESSION[ 'links_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		$input_username = $database -> dbescape( $user[ 'user_name' ] );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_links SET link_name = '" . $input_link_name . "', link_url = '" . $input_link_url . "', link_description = '" . $input_link_description . "', link_editip = '" . $ipaddr . "', link_editadmin = '" . $input_username . "' WHERE link_id = '" . $id . "'" );

		if( $insert[ 'link_category' ] )
		{
			$query = $database -> dbquery( "SELECT linkcat_seo FROM " . DB_PREFIX . "esselbach_ct_linkscats WHERE linkcat_id = '" . intval( $insert[ 'link_category' ] ) . "'" );
			list( $linkcat_seo ) = $database -> dbrow( $query );
			$category = "&category=" . $linkcat_seo . ".html";
		}
		else
		{
			$category = "";
		}

		header( "Location: {$insert['site_url']}/contentteller.php?ct=links" . $category );
		exit;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'links_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'links_header_html' ], $main_templates[ 'links_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'links_security_hash' ] = $system -> dorand();
		$_SESSION[ 'links_security_hash' ] = $insert[ 'links_security_hash' ];
		echo $templates -> exectemplate( $main_templates[ 'links_list_edit_html' ], $main_templates[ 'links_list_edit_php' ], $insert );
	}

	if( $preferences[ 'links_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'links_footer_html' ], $main_templates[ 'links_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>