<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.1                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2009 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529     Patch: 16                                                 |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function NewsEdit
 * A function to edit a news story
 * @author Philipp Louis Esselbach
 */
function NewsEdit( $id )
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','news_story_header','site_invalid_form','news_story_edit','news_story_edit_wysiwyg','news_story_rating_1star','news_story_rating_2stars','news_story_rating_3stars','news_story_rating_4stars','news_story_rating_5stars','news_story_footer','news_story_editreason','news_story_error_na','news_story_error_noadmin','news_story_error_notauthor'", $preferences[ 'current_theme' ] );

	if( !$id )
	{
		$id = 1;
	}

	$insert = $system -> getinsert( $preferences, $main_templates );
	$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_channels, newsstory_title, newsstory_seo, newsstory_rawstory, newsstory_rawextendedstory, newsstory_link, newsstory_description, newsstory_keywords, newsstory_teaser, newsstory_comments, newsstory_allowcomments, newsstory_html, newsstory_smilies, newsstory_code, newsstory_status, newsstory_password, newsstory_date, newsstory_startdate, newsstory_expiredate, newsstory_neverexpire, newsstory_poll, newsstory_fields, newsstory_views, newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid, newsstory_editadmin FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_id = '" . $id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'newsstory_id' ], $insert[ 'newsstory_author' ], $insert[ 'newsstory_channels' ], $insert[ 'newsstory_title' ], $insert[ 'newsstory_seo' ], $insert[ 'newsstory_story' ], $insert[ 'newsstory_extendedstory' ], $insert[ 'newsstory_link' ], $insert[ 'newsstory_description' ], $insert[ 'newsstory_keywords' ], $insert[ 'newsstory_teaser' ], $insert[ 'newsstory_comments' ], $insert[ 'newsstory_allowcomments' ], $insert[ 'newsstory_html' ], $insert[ 'newsstory_smilies' ], $insert[ 'newsstory_code' ], $insert[ 'newsstory_status' ], $insert[ 'newsstory_password' ], $insert[ 'newsstory_date' ], $insert[ 'newsstory_startdate' ], $insert[ 'newsstory_expiredate' ], $insert[ 'newsstory_neverexpire' ], $insert[ 'newsstory_poll' ], $insert[ 'newsstory_fields' ], $insert[ 'newsstory_views' ], $insert[ 'newsstory_rating' ], $insert[ 'newsstory_votes' ], $insert[ 'newsstory_source' ], $insert[ 'newsstory_sourceid' ], $insert[ 'newsstory_editadmin' ] ) = $database -> dbrow( $query );
		$insert[ 'newsstory_title' ] = htmlspecialchars( $insert[ 'newsstory_title' ] );
		$insert[ 'newsstory_story' ] = htmlspecialchars( $insert[ 'newsstory_story' ] );
		$insert[ 'newsstory_extendedstory' ] = htmlspecialchars( $insert[ 'newsstory_extendedstory' ] );
		$insert[ 'newsstory_link' ] = htmlspecialchars( $insert[ 'newsstory_link' ] );
		$insert[ 'newsstory_month' ] = $system -> convertdate( $insert[ 'newsstory_date' ], "%B %Y", $preferences[ 'website_timezone' ] );
		$insert[ 'newsstory_month_id' ] = $system -> getmonth( $insert[ 'newsstory_date' ] );
		$insert[ 'page_name' ] = $insert[ 'newsstory_title' ];
		$insert[ 'page_description' ] = $insert[ 'newsstory_description' ];
		$insert[ 'page_keywords' ] = $insert[ 'newsstory_keywords' ];
	}
	else
	{
		$insert[ 'page_name' ] = $preferences[ 'website_name' ];
		$insert[ 'page_description' ] = $preferences[ 'website_description' ];
		$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	}

	if( $user[ 'user_status' ] != 2 )
	{
		$error = $templates -> exectemplate( $main_templates[ 'news_story_error_noadmin_html' ], $main_templates[ 'news_story_error_noadmin_php' ], $insert );
	}

	if( $user[ 'user_status' ] == 2 and $insert[ 'newsstory_author' ] != $user[ 'user_name' ] )
	{
		$error = $templates -> exectemplate( $main_templates[ 'news_story_error_notauthor_html' ], $main_templates[ 'news_story_error_notauthor_php' ], $insert );
	}

	if( $preferences[ 'news_allow_rating' ] and $insert[ 'newsstory_votes' ] )
	{
		if( $insert[ 'newsstory_rating' ] == 5 )
		{
			$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_5stars_html' ], $main_templates[ 'news_story_rating_5stars_php' ], $insert );
		}
		elseif( $insert[ 'newsstory_rating' ] == 4 )
		{
			$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_4stars_html' ], $main_templates[ 'news_story_rating_4stars_php' ], $insert );
		}
		elseif( $insert[ 'newsstory_rating' ] == 3 )
		{
			$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_3stars_html' ], $main_templates[ 'news_story_rating_3stars_php' ], $insert );
		}
		elseif( $insert[ 'newsstory_rating' ] == 2 )
		{
			$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_2stars_html' ], $main_templates[ 'news_story_rating_2stars_php' ], $insert );
		}
		elseif( $insert[ 'newsstory_rating' ] < 2 )
		{
			$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_1star_html' ], $main_templates[ 'news_story_rating_1star_php' ], $insert );
		}
	}
	else
	{
		$insert[ 'newsstory_rating_line' ] = "";
	}

	$input_newsstory_title = ( isset( $_POST[ 'input_newsstory_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_title' ] ) : "" ;
	$input_newsstory_story = ( isset( $_POST[ 'input_newsstory_story' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_story' ] ) : "" ;
	$input_newsstory_extendedstory = ( isset( $_POST[ 'input_newsstory_extendedstory' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_extendedstory' ] ) : "" ;
	$input_newsstory_link = ( isset( $_POST[ 'input_newsstory_link' ] ) ) ? $security -> checkvar( $_POST[ 'input_newsstory_link' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $input_newsstory_title or $input_newsstory_story or $input_newsstory_extendedstory ) and( !isset( $error ) ) )
	{
		session_start();

		if( ( $_SESSION[ 'news_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
		{
			echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
			echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
			exit;
		}

		if( $preferences[ 'news_undo' ] )
		{
			$old_title = $database -> dbescape( $insert[ 'newsstory_title' ] );
			$old_story = $database -> dbescape( $insert[ 'newsstory_story' ] );
			$old_author = $database -> dbescape( $insert[ 'newsstory_author' ] );
			$old_extendedstory = $database -> dbescape( $insert[ 'newsstory_extendedstory' ] );
			$old_link = $database -> dbescape( $insert[ 'newsstory_link' ] );
			$old_description = $database -> dbescape( $insert[ 'newsstory_description' ] );
			$old_keywords = $database -> dbescape( $insert[ 'newsstory_keywords' ] );
			$old_poll = $database -> dbescape( $insert[ 'newsstory_poll' ] );
			$old_fields = $database -> dbescape( $insert[ 'newsstory_fields' ] );
			$old_date = $database -> dbescape( $insert[ 'newsstory_date' ] );
			$old_startdate = $database -> dbescape( $insert[ 'newsstory_startdate' ] );
			$old_expiredate = $database -> dbescape( $insert[ 'newsstory_expiredate' ] );
			$old_neverexpire = $database -> dbescape( $insert[ 'newsstory_neverexpire' ] );
			$old_source = $database -> dbescape( $insert[ 'newsstory_source' ] );
			$old_sourceid = $database -> dbescape( $insert[ 'newsstory_sourceid' ] );
			$old_editadmin = $database -> dbescape( $insert[ 'newsstory_editadmin' ] );
			$edit_reason = $database -> dbescape( $templates -> exectemplate( $main_templates[ 'news_story_editreason_html' ], $main_templates[ 'news_story_editreason_php' ], $insert ) );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsstoriesundo (newsstoryundo_id, newsstoryundo_storyid, newsstoryundo_author, newsstoryundo_title, newsstoryundo_story, newsstoryundo_extendedstory, newsstoryundo_link, newsstoryundo_description, newsstoryundo_keywords, newsstoryundo_date, newsstoryundo_startdate, newsstoryundo_expiredate, newsstoryundo_neverexpire, newsstoryundo_poll, newsstoryundo_fields, newsstoryundo_source, newsstoryundo_sourceid, newsstoryundo_editip, newsstoryundo_editadmin, newsstoryundo_editreason) VALUES (NULL, '" . $id . "', '" . $old_author . "', '" . $old_title . "', '" . $old_story . "', '" . $old_extendedstory . "', '" . $old_link . "', '" . $old_description . "', '" . $old_keywords . "', '" . $old_date . "', '" . $old_startdate . "', '" . $old_expiredate . "', '" . $old_neverexpire . "', '" . $old_poll . "', '" . $old_fields . "', '" . $old_source . "', '" . $old_sourceid . "', '" . $ipaddr . "', '" . $old_editadmin . "', '" . $edit_reason . "')" );
		}

		$input_username = $database -> dbescape( $user[ 'user_name' ] );
		$input_newsstory_story_parsed = stripslashes( $input_newsstory_story );
		$input_newsstory_extendedstory_parsed = stripslashes( $input_newsstory_extendedstory );

		if( !$insert[ 'newsstory_html' ] )
		{
			$input_newsstory_story_parsed = $system -> dechomp( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> dechomp( $input_newsstory_extendedstory_parsed );
		}

		if( $insert[ 'newsstory_smilies' ] )
		{
			$input_newsstory_story_parsed = $system -> smilies( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> smilies( $input_newsstory_extendedstory_parsed );
		}

		if( $insert[ 'newsstory_code' ] )
		{
			$input_newsstory_story_parsed = $system -> code( $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = $system -> code( $input_newsstory_extendedstory_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=news&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_newsstory_story_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=news&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_newsstory_story_parsed );
			$input_newsstory_story_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\"><img src=\"contentteller.php?ct=news&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_newsstory_story_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=news&amp;action=attachments&amp;id=\\1\">\\2</a>", $input_newsstory_extendedstory_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=news&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_newsstory_extendedstory_parsed );
			$input_newsstory_extendedstory_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "news" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\"><img src=\"contentteller.php?ct=news&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_newsstory_extendedstory_parsed );
		}

		$input_newsstory_story_parsed = $database -> dbescape( $input_newsstory_story_parsed );
		$input_newsstory_extendedstory_parsed = $database -> dbescape( $input_newsstory_extendedstory_parsed );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_title = '" . $input_newsstory_title . "', newsstory_rawstory = '" . $input_newsstory_story . "', newsstory_story = '" . $input_newsstory_story_parsed . "', newsstory_rawextendedstory = '" . $input_newsstory_extendedstory . "', newsstory_extendedstory = '" . $input_newsstory_extendedstory_parsed . "', newsstory_link = '" . $input_newsstory_link . "', newsstory_editip = '" . $ipaddr . "', newsstory_editadmin = '" . $input_username . "' WHERE newsstory_id = '" . $id . "'" );
		header( "Location: {$insert['site_url']}/contentteller.php?ct=news&action=story&page=" . $insert[ 'newsstory_seo' ] . ".html" );
		exit;
	}

	$templates -> initgzip();
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'news_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'news_story_header_html' ], $main_templates[ 'news_story_header_php' ], $insert );
	}

	if( isset( $error ) )
	{
		echo $error;
	}
	else
	{
		session_start();
		$insert[ 'news_security_hash' ] = $system -> dorand();
		$_SESSION[ 'news_security_hash' ] = $insert[ 'news_security_hash' ];

		if( $insert[ 'newsstory_html' ] and $preferences[ 'news_wysiwyg' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'news_story_edit_wysiwyg_html' ], $main_templates[ 'news_story_edit_wysiwyg_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'news_story_edit_html' ], $main_templates[ 'news_story_edit_php' ], $insert );
		}
	}

	if( $preferences[ 'news_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'news_story_footer_html' ], $main_templates[ 'news_story_footer_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>